﻿-- (1) - Crear vista: consulta1

CREATE OR REPLACE VIEW CONSULTA1 AS 
  SELECT 
    clientes.`CÓDIGO CLIENTE` AS 'CÓDIGO CLIENTE',
    `NÚMERO DE PEDIDO` AS 'NÚMERO DE PEDIDO',
    EMPRESA AS 'EMPRESA',
    POBLACIÓN AS 'POBLACIÓN'
  FROM clientes 
    JOIN pedidos 
      ON clientes.`CÓDIGO CLIENTE` = pedidos.`CÓDIGO CLIENTE`
  WHERE POBLACIÓN IN('madrid','barcelona','zaragoza');


-- (2) - Modificación de la vista: consulta1

-- consulta c1

SELECT `CÓDIGO CLIENTE`, EMPRESA, POBLACIÓN FROM clientes
  WHERE POBLACIÓN IN ('madrid','barcelona','zaragoza');

-- consulta completa

CREATE OR REPLACE VIEW CONSULTA1OPTIMIZADA AS
SELECT 
  c1.`CÓDIGO CLIENTE`,
  EMPRESA,
  POBLACIÓN,
  `NÚMERO DE PEDIDO`  
  FROM pedidos 
  JOIN (
    SELECT `CÓDIGO CLIENTE`, EMPRESA, POBLACIÓN FROM clientes
    WHERE POBLACIÓN IN ('madrid','barcelona','zaragoza')
    )c1
  USING (`NÚMERO DE PEDIDO`);

-- (3) CONSULTA OPTIMIZADA CON SUBCONSULTA

CREATE OR REPLACE VIEW SUBCONSULTA1CONSULTA1OPTIMIZADA AS
SELECT `CÓDIGO CLIENTE`, 
        `EMPRESA`,
        `POBLACIÓN`
  FROM clientes
  WHERE POBLACIÓN IN('madrid','barcelona','zaragoza');

CREATE OR REPLACE VIEW CONSULTA1OPTIMIZADA AS
SELECT `NÚMERO DE PEDIDO` AS `NÚMERO DE PEDIDO`,
        S.`CÓDIGO CLIENTE` AS `CODIGO CLIENTE`,
        S.`EMPRESA` AS `EMPRESA`,
        S.`POBLACIÓN` AS `POBLACIÓN`
FROM PEDIDOS 
  JOIN SUBCONSULTA1CONSULTA1OPTIMIZADA S
    ON PEDIDOS.`CÓDIGO CLIENTE`=S.`CÓDIGO CLIENTE`;

-- (5) VISTA CONSULTA 2

-- consulta c1 (vista subconsulta1consulta2

CREATE OR REPLACE VIEW subconsulta1consulta2 AS 
SELECT 
  `NÚMERO DE PEDIDO`,
  `FECHA DE PEDIDO`,
  `FORMA DE PAGO`,
  `CÓDIGO CLIENTE` 
FROM pedidos
WHERE YEAR(`FECHA DE PEDIDO`)=2002 AND `FORMA DE PAGO`='tarjeta';

-- vista consulta2

CREATE OR REPLACE VIEW CONSULTA2 AS
SELECT
  EMPRESA AS `EMPRESA`,
  POBLACIÓN AS `POBLACIÓN`,
  C1.`NÚMERO DE PEDIDO` AS `NÚMERO DE PEDIDO`,
  C1.`FECHA DE PEDIDO` AS `FECHA DE PEDIDO`,  
  C1.`FORMA DE PAGO` AS `FORMA DE PAGO`
FROM clientes
  JOIN subconsulta1consulta2 C1
    ON clientes.`CÓDIGO CLIENTE`=c1.`CÓDIGO CLIENTE`
ORDER BY C1.`CÓDIGO CLIENTE`;

-- (6) CONSULTA 3

CREATE OR REPLACE VIEW C1CONSULTA3 AS
  SELECT 
    COUNT(*) AS `Npedidos`,
    `CÓDIGO CLIENTE` AS `CÓDIGO CLIENTE`
  FROM pedidos
  GROUP BY `CÓDIGO CLIENTE`;

CREATE OR REPLACE VIEW C2CONSULTA3 AS
  SELECT 
    MAX(C1.`Npedidos`) AS `maximo` 
  FROM C1CONSULTA3 C1;

CREATE OR REPLACE VIEW C3CONSULTA3 AS
  SELECT 
    c1.`CÓDIGO CLIENTE` AS `CÓDIGO CLIENTE` 
  FROM c1consulta3 c1
   JOIN C2CONSULTA3 c2
      ON c1.`Npedidos`=c2.`maximo`;

CREATE OR REPLACE VIEW CONSULTA3 AS
  SELECT 
    clientes.`CÓDIGO CLIENTE` AS `CÓDIGO CLIENTE`,
    clientes.TELÉFONO AS `TELÉFONO`
  FROM C3CONSULTA3 c3
    JOIN clientes
      ON C3.`CÓDIGO CLIENTE`=clientes.`CÓDIGO CLIENTE`;
